%define ALD_Ver		1.2.4

%define       STATIC_WEBKIT 1
%define       pkgrelnr 32.4

Name:         midori

License:      LGPL
Summary:      Midori is a lightweight web browser.
Group:        Networking/Utilities
Version:      0.5.11

Release:      2.4.11.1s

Source: %{name}-%{version}.tar.xz
Source1: CROSS.sh
Source2: %{name}-%{version}-patches.tgz

%define DestDir		/Gtk/%{pkgrelnr}
# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%else
# rpm --target=x86_64/armv6l/win32 -ba xxxxx.spec
%define _CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%if %{_CROSS}

%if %{_os} == "mingw"
%define target %{_arch}-%{_vendor}-%{_os}%{__isa_bits}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif
%define target_  %{target}-

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin

%define __os_install_post %{nil}

%define cross_prefix	%{csysdir}%{_prefix}
%define cross_sysconfdir %{csysdir}%{_sysconfdir}
%define cross_bindir	%{csysdir}%{_bindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_gtk_docdir %{csysdir}%{_defaultdocdir}/gtk2-doc
%define cross_docdir	%{cross_gtk_docdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define csysdir		%{nil}

%define target %{_build}
%define target_  %{nil}

%endif # !_CROSS

%define gtk_docdir %{_defaultdocdir}/gtk2-doc
%define docdir %{gtk_docdir}/%{name}

# ------------------- description ------------------------------------
%description
Midori is a lightweight web browser.
#-------------------------------
%package locale
Summary:      locale
Group:        Applications/Languages
%description locale
Locale

# ------------------- setup ------------------------------------------
%Prep
%setup -q

sed -i s:" -g":: CMakeLists.txt
sed -i s:"-g -fPIC":"-fPIC": CMakeLists.txt

tar -xaf %SOURCE2
patch -p1<patches/Passing-non-NULL-string-sourceURL-to-JSEvaluateScrip.patch
patch -p0<patches/vala-0.36.patch
patch -p0<patches/del_tests.patch
#patch -p0<patches/webkit_static_link.patch
patch -p0<patches/small-bookmark.patch
patch -p0<patches/update-Chrome-version.patch
patch -p0<patches/no_text_editor.patch
patch -p0<patches/open_with_cancel_no_loop.patch
patch -p0<patches/use_only_WebKitSoupAuthDialog.patch
#patch -p0<patches/force_set_font.patch

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

GCC_VER_STR=`%{target_}gcc -dumpversion`
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-asynchronous-unwind-tables" ;; esac`
LDFLAGS=" "

%if %{_arch} == "i386"
case $GCC_VER_STR in
  4.9.*) OPTFLAGS="-O2 -march=i586" ;;
  *)     OPTFLAGS="-O2 -march=i486" ;;
esac
OPTFLAGS="$OPTFLAGS -mpreferred-stack-boundary=3 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer $OPT47"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2 $OPT47"
LDFLAGS=`case $GCC_VER_STR in 4.[56789].*) echo -static-libgcc ;; esac`
%endif
%if %{_arch} == "arm"
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access $OPT47"
%endif

#export CFLAGS="-pipe $OPTFLAGS -fno-rtti -ffunction-sections -fdata-sections -std=gnu99"
#export CXXFLAGS="-pipe $OPTFLAGS -fno-rtti -ffunction-sections -fdata-sections"
#export LDFLAGS="$LDFLAGS -Wl,--gc-sections"

export CFLAGS="$OPTFLAGS -ffunction-sections -fdata-sections -std=gnu99"
export CXXFLAGS="$OPTFLAGS"
export LDFLAGS="-Wl,--gc-sections -L/usr/X11/%{_lib}"

CC=%{target_}gcc
CPP=%{target_}cpp
AR=%{target_}ar
RANLIB=%{target_}ranlib
export CC CPP AR RANLIB

export PKG_CONFIG_PATH=" "

%if 1
./configure \
	--prefix=%{_prefix} \
	--disable-zeitgeist
%endif
#	--enable-gtk3

#	&>FConfigure_log.txt

%if %{STATIC_WEBKIT}
STATIC_CPP=`%{target_}gcc -print-file-name=libstdc++.a`
patches/runtime_static_webkit %{csysdir}%{_libdir} $STATIC_CPP
cp -a patches/symbols.filter _build/midori/
cp -a patches/test_undefined_symbol _build/midori/
%endif

make &>FMake_log.txt

%if %{STATIC_WEBKIT}
pushd _build/midori/ >/dev/null
 ./test_undefined_symbol
popd >/dev/null
%endif

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}

CC=%{target_}gcc
CPP=%{target_}cpp
AR=%{target_}ar
RANLIB=%{target_}ranlib
export CC CPP AR RANLIB

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt

if test -x /usr/bin/rsvg-convert; then
pushd $RPM_BUILD_ROOT%{_datadir}/icons/hicolor
  for i in 24 32 48; do
    mkdir -p ${i}x${i}/apps
    rsvg-convert -w $i -h $i -o ${i}x${i}/apps/midori.png scalable/apps/midori.svg
    mkdir -p ${i}x${i}/categories
    rsvg-convert -w $i -h $i -o ${i}x${i}/categories/extension.png scalable/categories/extension.svg
    mkdir -p ${i}x${i}/status
    rsvg-convert -w $i -h $i -o ${i}x${i}/status/internet-news-reader.png scalable/status/internet-news-reader.svg
  done
popd
fi

%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=0
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
%endif #_CROSS

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean
%if %{STATIC_WEBKIT}
DE=swk-%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
%else
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
%endif
pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
%if (%{_os} == "mingw")
  rm %{name}-$SE
%else  #mingw
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-locale-$SE $DD/%{name}-locale-$DE
%endif #!mingw
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
%if (%{_os} == "mingw")
  TMP_TO=$DD
%else
  TMP_TO=$DD/tar
%endif
  mkdir -p $TMP_TO
%if %{STATIC_WEBKIT}
  tmp=%{name}-swk-%{version}-%{release}.%{TO_ARCH}
%else
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
%endif
  mkdir -p $tmp
  cp -r etc usr $tmp/
%if (%{_os} == "mingw")
  zip -9 -r $tmp.zip $tmp >/dev/null
  mv $tmp.zip $TMP_TO
%else
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
%endif
  rm -r $tmp
popd
%endif  #BUILD_TAR

%post
if test -d $HOME/.ALDccp/Menu/StartMenu/Programs; then
  if ! test -d $HOME/.ALDccp/Menu/StartMenu/Programs/Network; then
    mkdir -p $HOME/.ALDccp/Menu/StartMenu/Programs/Network
    printf "[Desktop Entry]\nType=Directory\nName=Network\nIcon=network\n" >$HOME/.ALDccp/Menu/StartMenu/Programs/Network/.directory
  fi
  cp /usr/share/applications/midori.desktop $HOME/.ALDccp/Menu/StartMenu/Programs/Network
  printf "[Desktop Entry]\nType=Application\nName=Midori\nMimeType=text/html;application/xhtml+xml;x-scheme-handler/http;x-scheme-handler/https;x-scheme-handler/geo;image/svg+xml;\nExec=midori -p %%%%U\nIcon=midori\n" >$HOME/.ALDccp/share/applications/midori.desktop
fi

if test -d $HOME/.ALDccp/Desktop; then
  cp /usr/share/applications/midori.desktop $HOME/.ALDccp/Desktop/
fi

%postun
if test ! -e /usr/share/applications/midori.desktop; then
  rm -f $HOME/.ALDccp/Menu/StartMenu/Programs/Network/midori.desktop
  tmp=`ls $HOME/.ALDccp/Menu/StartMenu/Programs/Network/*.desktop 2>/dev/null`
  if test $? != 0; then
    rm -rf $HOME/.ALDccp/Menu/StartMenu/Programs/Network
  fi

  rm -f $HOME/.ALDccp/Desktop/midori.desktop
  rm -f $HOME/.ALDccp/share/applications/midori.desktop
fi

# ------------------- Files ------------------------------------------
%if %{_os} == "mingw"
%files
%{_prefix}
%else  #mingw

%files
%{_sysconfdir}
%{_bindir}
%{_libdir}
%{_datadir}/appdata
%{_datadir}/applications
%{_datadir}/doc
%{_datadir}/icons
%{_datadir}/midori

%files locale
%{_datadir}/locale


%endif #!mingw
